﻿using System;
using System.IO;
using System.Reflection;
using System.Windows;
using System.Windows.Markup;
using System.Windows.Resources;

namespace TestProject
{
    /// <summary>
    /// BAML 리더
    /// </summary>
    public static class BAMLReader
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 리소스 스트림 구하기 - GetResourceStream(assemblyName, resourcePath)

        /// <summary>
        /// 리소스 스트림 구하기
        /// </summary>
        /// <param name="assemblyName">어셈블리명</param>
        /// <param name="resourcePath">리소스 경로</param>
        /// <returns>리소스 스트림</returns>
        public static Stream GetResourceStream(string assemblyName, string resourcePath)
        {
            Uri uri = new Uri($"/{assemblyName};component/{resourcePath}", UriKind.Relative);

            StreamResourceInfo streamResourceInfo = Application.GetResourceStream(uri);

            return streamResourceInfo.Stream;
        }

        #endregion
        #region 로드하기 - Load(stream)

        /// <summary>
        /// 로드하기
        /// </summary>
        /// <param name="stream">스트림</param>
        /// <returns>객체</returns>
        public static object Load(Stream stream)
        {
            ParserContext context = new ParserContext();

            MethodInfo methodInfo = typeof(XamlReader).GetMethod("LoadBaml", BindingFlags.NonPublic | BindingFlags.Static);

            return methodInfo.Invoke(null, new object[] { stream, context, null, false });
        }

        #endregion
    }
}